# -*- coding: utf-8 -*-

import random
import numpy as np

########################
# Solution tic-tac-toe #
########################

#####
# joueur_alpha_beta_tic_tac_toe : Fonction qui calcule le prochain coup optimal pour gagner la
#                                 la partie de Tic-tac-toe à l'aide d'Alpha-Beta Prunning.
#
# etat: Objet de la classe TicTacToeEtat indiquant l'état actuel du jeu.
#
# fct_but: Fonction qui prend en entrée un objet de la classe TicTacToeEtat et
#          qui retourne le score actuel tu plateau. Si le score est positif, les 'X' ont l'avantage
#          si c'est négatif ce sont les 'O' qui ont l'avantage, si c'est 0 la partie est nulle.
#
# fct_transitions: Fonction qui prend en entrée un objet de la classe TicTacToeEtat et 
#                   qui retourne une liste de tuples actions-états voisins pour l'état donné.
#
# str_joueur: String indiquant c'est à qui de jouer : les 'X' ou 'O'.
#
# retour: Cette fonction retourne l'action optimal à joeur pour le joueur actuel c.-à-d. 'str_joueur'.
###  
def joueur_tictactoe(etat,fct_but,fct_transitions,str_joueur):
    
    #TODO: Implémenter un joueur alpha-beta
    
    #Retourne un action aléatoire (à modifier)
    action,etat = random.choice(fct_transitions(etat).items())
    return action    
